import { EditorPluginProps, EditorPlugin } from '@edtr-io/plugin';
import * as React from 'react';
import { HighlightRendererProps } from './renderer';
declare const highlightState: import("@edtr-io/internal__plugin-state").StateType<import("@edtr-io/internal__plugin-state").StateTypesSerializedType<{
    text: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    language: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    lineNumbers: import("@edtr-io/internal__plugin-state").StateType<boolean, boolean, {
        value: boolean;
        get(): boolean;
        set(value: boolean | ((currentValue: boolean) => boolean)): void;
    }>;
}>, import("@edtr-io/internal__plugin-state").StateTypesValueType<{
    text: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    language: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    lineNumbers: import("@edtr-io/internal__plugin-state").StateType<boolean, boolean, {
        value: boolean;
        get(): boolean;
        set(value: boolean | ((currentValue: boolean) => boolean)): void;
    }>;
}>, import("@edtr-io/internal__plugin-state").StateTypesReturnType<{
    text: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    language: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    lineNumbers: import("@edtr-io/internal__plugin-state").StateType<boolean, boolean, {
        value: boolean;
        get(): boolean;
        set(value: boolean | ((currentValue: boolean) => boolean)): void;
    }>;
}>>;
export declare type HighlightState = typeof highlightState;
export interface HighlightConfig {
    Renderer: React.ComponentType<HighlightRendererProps>;
}
export declare type HighlightProps = EditorPluginProps<HighlightState, HighlightConfig>;
export declare function createHighlightPlugin(config?: HighlightConfig): EditorPlugin<HighlightState, HighlightConfig>;
export {};
//# sourceMappingURL=index.d.ts.map